#pragma once
#include <SFML/Graphics.hpp>
#include <vector>

namespace LD46
{
	class TextureManager;

	class AnimatedSprite
	{
	public:
		AnimatedSprite(TextureManager texMgr, const int resourceId, const int width, const int height, const float speed, bool playOnce, const int originX = -1, const int originY = -1);
		~AnimatedSprite();
		bool Update(const sf::Time& tm);
		void Draw(sf::RenderWindow& wnd, sf::Shader* shdr = nullptr);
		void Play(bool reverse = false);
		void Stop();
		sf::Vector2f Pos() const;
		void SetPos(const sf::Vector2f& pos);
		void SetScale(const sf::Vector2f& scale);
		const sf::Vector2f& Scale() const;
		void SetOrigin(const sf::Vector2f& center);
		bool IsFinished() const;
		float CurrentFrame() const;
	private:
		void Next(const float elapsedTime);
		void Previous(const float elapsedTime);
		void UpdateSpriteMapping();
		TextureManager& m_texMgr;
		const int m_width;
		const int m_height;
		const float m_speed;
		float m_currentFrame;
		int m_totalFrames;
		bool m_revesePlay;
		bool m_play;
		bool m_playOnce;
		bool m_isFinished;
		bool m_firstRound;
		sf::Time m_prevTime;
		sf::Texture m_texture;
		sf::Sprite m_sprite1;
		sf::Sprite m_sprite2;
	};
}