#include "stdafx.h"
#include "Explosion.h"
#include "TextureManager.h"
#include "resource.h"

namespace LD46
{
	long Explosion::s_id = 1;
	Explosion::Explosion(TextureManager& txMgr, const sf::Vector3f& pos, ExplosionType et, const float scale /*= 1.0f*/)
		:m_txMgr(txMgr)
		, m_pos(pos.x, pos.y)
		, m_scale(0.0)
		, m_explType(et)
		, m_xtraScale(scale)
		, m_id(s_id++)
	{
		//auto& t = txMgr.GetTexture(IDB_EXPLOSION);
		//m_spr.setTexture(t);
		//const auto& sz = t.getSize();
		//m_spr.setOrigin(sf::Vector2f(sz.x / 2.0f, sz.y / 2.0f));
	}

	bool Explosion::Update(const sf::Time& tm)
	{
		m_spr.setPosition(m_pos);
		if (m_explType == ExplosionType::Explosion1)
		{
			m_scale += 0.1f;
			auto s = cos(m_scale) * m_xtraScale;
			m_spr.setScale(sf::Vector2f(s, s));
			return m_scale < 3.14159265 / 2;
		}
		else
		{
			m_scale += 0.05f;
			auto s = sin(m_scale)*0.5 * m_xtraScale;
			m_spr.setScale(sf::Vector2f(s, s));
			return m_scale < 3.14159265;
		}		
		return m_scale < 3.14159265 / 2;
	}

	void Explosion::Draw(sf::RenderWindow& wnd)
	{
		wnd.draw(m_spr);
	}

	long Explosion::Id() const
	{
		return m_id;
	}
}