#pragma once
#include <SFML/Graphics.hpp>
#include <memory>

namespace LD46
{
	class TextureManager;
	class Hero;

	class Explosion
	{
	public:
		enum class ExplosionType
		{
			Explosion1,
			Star
		};

		Explosion(TextureManager& txMgr, const sf::Vector3f& pos, ExplosionType t, const float scale = 1.0f);
		bool Update(const sf::Time& tm);
		void Draw(sf::RenderWindow& wnd);
		long Id() const;

	private:
		static long s_id;
		const long m_id;

		TextureManager& m_txMgr;

		ExplosionType m_explType;
		sf::Sprite m_spr;
		sf::Vector2f m_pos;

		float m_scale;
		float m_xtraScale;
	};

	typedef std::shared_ptr<Explosion> ExplosionPtr;
}