#include "stdafx.h"
#include "FontTextMgr.h"

namespace LD46
{
	sf::Font& FontTextMgr::LoadFontInResource(int name)
	{
		HMODULE handle = ::GetModuleHandle(NULL);
		HRSRC rc = ::FindResource(handle, MAKEINTRESOURCE(name),
			RT_RCDATA);
		HGLOBAL rcData = ::LoadResource(handle, rc);
		auto sz = ::SizeofResource(handle, rc);
		auto data = static_cast<void*>(::LockResource(rcData));
		auto& fnt = m_fonts[name];
		fnt.loadFromMemory(data, sz);
		return fnt;
	}

	std::string FontTextMgr::LoadTextInResource(int name)
	{
		HMODULE handle = ::GetModuleHandle(NULL);
		HRSRC rc = ::FindResource(handle, MAKEINTRESOURCE(name),
			RT_RCDATA);
		HGLOBAL rcData = ::LoadResource(handle, rc);
		auto sz = ::SizeofResource(handle, rc);
		auto data = static_cast<char*>(::LockResource(rcData));
		auto& text = m_texts[name];
		text = std::string(data);
		return text;
	}

	FontTextMgr::~FontTextMgr()
	{
	}

}