#include "stdafx.h"
#include "HookedRenderWindow.h"

namespace LD46
{
	HookedRenderWindow::HookedRenderWindow(sf::ContextSettings settings, const sf::Vector2u& winSize)
		:sf::RenderWindow(sf::VideoMode(640, 400), "Of the Dark", sf::Style::Default, settings)
		, m_shd(nullptr)
	{
		this->setSize(winSize);
		auto& dm = sf::VideoMode::getDesktopMode();
		this->setPosition(sf::Vector2i(dm.width / 2 - 640, dm.height / 2 - 400));
	}
	
	void HookedRenderWindow::SetShader(sf::Shader* shd)
	{
		m_shd = shd;
	}
	
	void HookedRenderWindow::onResize()
	{
		sf::RenderWindow::onResize();

		if (m_shd == nullptr)
			return;

		auto wsz = getSize();
		m_shd->setUniform("resolution", sf::Vector2f(wsz.x, wsz.y));
		//m_shd->setUniform("scaling", 640.0f / wsz.x);
	}
}