#pragma once
#include <SFML/Graphics.hpp>
#include <memory>

namespace LD46
{
	class TextureManager;
	class FontTextMgr;
	class Hero;
	using HeroPtr = std::shared_ptr<Hero>;

	class Hud
	{
	public:
		Hud(TextureManager& txMgr, FontTextMgr& ftMgr, HeroPtr hero);
		~Hud();

		void Draw(sf::RenderWindow& wnd);
		bool Update(const sf::Time& tm);
		void TextDisplay(const std::string& txt, int time);
		void ShowInfoText(bool force);
	private:
		TextureManager& m_txMgr;
		FontTextMgr& m_ftMgr;
		HeroPtr m_hero;
		sf::Sprite m_border;
		sf::Sprite m_overlay;
		sf::Sprite m_map;
		sf::Text m_infoTxt;
		sf::Time m_prevTime;
		sf::RectangleShape m_point;
		bool m_forceShowText;
		int m_countDownTime;
		int m_tickIn;
	};
}