#pragma once

namespace LD46
{
	enum class InputAction
	{
		None,
		CloseWindow = 1,
		ExitIngame = 2,
		Skipper = 4,
		LeftButton = 8,
		RightButton = 16,
		Left = 32,
		Right = 64,
		Up = 128,
		Down = 256,
		MainButton_A = 512,
		Button_X = 1024,
		BackButton_B = 2048,
		Button_Y = 4096,
	};
	class HookedRenderWindow;

	class InputManager
	{
	public:
		InputManager(HookedRenderWindow& window);
		~InputManager();

		int DetectJoystick();
		void Update();
		bool IsAction(InputAction action) const;
	private:

		HookedRenderWindow& m_window;
		int m_detectedJoystick;
		InputAction m_action;
	};
}